require 'socket'
require 'uuid'

module PRFLR

	class Client

	    def initialize(opts = {})
	    	@host 		= opts[:host]
      		@port		= opts[:port]
      		@source		= opts[:source]
      		@apiKey		= opts[:apikey]
      		@timers 	= {}
      		@threadId	= UUID.new.generate
      		@socket		= UDPSocket.new
	    end

	    def begin(timer)
	    	@timers[timer] = Time.now.to_i
	    end

	    def finish(timer, info = nil)
	    	time = ((Time.now.to_i - @timers[timer]) * 1000).round(3)
	    	send(timer, time, info)
	    end

	    def send(timer, time, info)
	    	message = "#{@threadId[0..32].sub('|','')}|#{@source[0..32].sub('|','')}|#{timer[0..48].sub('|','')}|#{time}|#{info[0..32]}|#{@apiKey[0..32]}"
	    	@socket.send(message, 0, @host, @port)
	    end

	    def finalize(object_id)
    		@socket.close
  		end
	end

end